include "ZeroPage.inc"
include "VVram.inc"
include "Chars.inc"

ext VVram_
ext Map_
ext BaseX_, BaseY_

MapStep equ 8

pSource equ ZW0
pDestination equ ZW1
; count equ ZB3


; ptr<byte> VVramPtr(byte x, byte y);
dseg
VVramPtr_@Param0: public	VVramPtr_@Param0
VVramPtr_.x_:	defs 1
VVramPtr_@Param1: public	VVramPtr_@Param1
VVramPtr_.y_:	defs 1
cseg
VVramPtr_: public	VVramPtr_
        pha
                lda	VVramPtr_.y_
                asl a ;*2
                clc|adc VVramPtr_.y_ ;*3
                asl a  ;*6
                sta <pDestination | lda #0 | sta <pDestination+1
                asl <pDestination | rol <pDestination+1 ;12
                asl <pDestination | rol <pDestination+1 ;24
                lda VVramPtr_.x_ | clc | adc <pDestination | sta <pDestination
                lda <pDestination+1 | adc #0 | sta <pDestination+1
                lda <pDestination | clc|adc #low VVram_ | tay
                lda <pDestination+1 | adc #high VVram_ | tax
        pla
rts


; void MapToVVram();
dseg
map.offset defb 0
map.byte defb 0
cseg
MapToVVram_: public MapToVVram_
        pha
                lda BaseY_
                sta <pSource+0
                lda #0
                sta <pSource+1
                asl <pSource+0   ; *2
                rol <pSource+1
                asl <pSource+0   ; *4
                rol <pSource+1
                asl <pSource+0   ; *8 : MapStep
                rol <pSource+1
                lda <pSource+0
                clc
                adc #low Map_
                sta <pSource+0
                lda <pSource+1
                adc #high Map_
                sta <pSource+1

                lda BaseX_
                lsr a
                lsr a
                lsr a
                clc
                adc <pSource+0
                sta <pSource+0
                lda <pSource+1
                adc #0
                sta <pSource+1
                ldy #0
                sty map.offset

                lda #1
                sta map.byte
                lda BaseX_
                and #7
                sta <ZB0
                do | while ne
                        asl map.byte
                        dec <ZB0
                wend
                lda #low VVram_
                sta <pDestination+0
                lda #high VVram_
                sta <pDestination+1
                lda #VVramHeight
                sta <ZB0
                ldx #0
                do
                        lda #VVramWidth
                        sta <ZB1
                        ldy map.offset
                        do
                        lda (<pSource),y
                        and map.byte
                        if ne
                                lda #Char_Wall
                        else
                                lda #Char_Space
                        endif
                        sta (<pDestination,x)
                        lda <pDestination+0
                        clc
                        adc #1
                        sta <pDestination+0
                        lda <pDestination+1
                        adc #0
                        sta <pDestination+1
                        asl map.byte
                        if eq
                                iny
                                inc map.byte
                        endif
                        dec <ZB1
                        while ne | wend
                        lda map.offset
                        clc
                        adc #MapStep
                        sta map.offset
                        dec <ZB0
                while ne | wend
        pla
rts
